//+------------------------------------------------------------------	+
//|                            Move_Stops_To_PSAR.mq4	 |
//|                                                               BD	 |
//|                                                                   	 |
//+------------------------------------------------------------------	+
#property copyright "Copyright  2012, SelectFX"
#property link      "http://www.selectfx.net"

extern int MagicNumber=0;
extern double PSARStep = 0.01;
extern double PSARMax =  0.2;
extern double iShift = 0;
extern int    MinProfitPoint=10;
extern bool CheckEveryTick = true;

string strSymbol;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
    {
//----

//----
    return(0);
    }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
    {
//----

//----
    return(0);
    }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
    {
//----

    strSymbol = Symbol();

    if ((!CheckEveryTick) && (Volume[0]==1))   // Go for it on first tick only
        {
        MoveStopsToPSAR(MagicNumber, 1);
        return(0);
        }

    if(CheckEveryTick)
        {
        MoveStopsToPSAR(MagicNumber, 0);    // Check for Stop move every tick
        }


//----
    return(0);
    }
//+------------------------------------------------------------------+

void MoveStopsToPSAR(int iMN, int iShift)
    {
    int icnt, itotal;
    double ActiveSAR;

    double Close_1 = Close[iShift];

    ActiveSAR = iSAR(NULL,0,PSARStep,PSARMax,iShift);


    itotal=OrdersTotal();

    for(icnt=0; icnt<itotal; icnt++)
        {
        // order loop boundary
        OrderSelect(icnt, SELECT_BY_POS, MODE_TRADES);
        // check for opened position, symbol & MagicNumber
        if(OrderType()==OP_SELL && OrderSymbol()==strSymbol  && OrderMagicNumber()==iMN)
            {
            if ((ActiveSAR > Close_1) && (ActiveSAR!=OrderStopLoss()))
                if (OrderOpenPrice()-MinProfitPoint*Point > Bid)
                    {
                    OrderModify(OrderTicket(),OrderOpenPrice(),ActiveSAR,OrderTakeProfit(),0,CLR_NONE);
                    }
            }


        if(OrderType()==OP_BUY && OrderSymbol()==strSymbol  && OrderMagicNumber()==iMN)
            {
            if ((ActiveSAR < Close_1) && (ActiveSAR!=OrderStopLoss()))
                if (OrderOpenPrice()+MinProfitPoint*Point < Ask)

                    {
                    OrderModify(OrderTicket(),OrderOpenPrice(),ActiveSAR,OrderTakeProfit(),0,CLR_NONE);
                    }
            }

        }  // order loop boundary

    return(0);

    }